\section{Trees}

\begin{frame}{Trees}
    \textbf{Special Case:}\\
    \vspace{0.5cm}
    $V,F\subseteq V(T), d=d_T$ for a \alert{tree} $T$. \\
    \vspace{0.5cm}
    %Here, $d_T(u,v)=c(p_{[u,v]})=\sum_{e\in p_{[u,v]}}c(e)$ where $p_{[u,v]}$ is the shortest path between $u,v\in V(T)$.
    $d_T:$ shortest path distance in $T$
    
    \vspace{0.5cm}

    \textbf{Additional Requirements:}\\
    \begin{itemize}
        \item $F_1=...=F_k$
        \item $\alpha=0$
    \end{itemize}

    \begin{theorem}
        This restriction of CFR is \alert{solvable in polynomial time.}
    \end{theorem}

\end{frame}


\begin{frame}{Trees}
    \textbf{Notation:} \\
    $F_{d_i}(v):=\{f\in F_i| v\in B_{d_i}(f)\}$ (level $i$ facilities covering $v$)
    \\
    \begin{lemma}
        Let $v\in V$ have \alert{maximum depth} $d(v)$. \\
        Then there exists an $f^*\in F_{d_i}(v)$ with \[B_{d_j}(f)\subseteq B_{d_j}(f^*)\] for all $f\in F_{d_i}(v)$ and all $j\geq i$.
    \end{lemma}
    \begin{center}
        $\Longrightarrow \ f^*$ provides \alert{maximum coverage on all levels}.
    \end{center}
    
\end{frame}

\begin{frame}{Trees}
    \begin{proof}[Proof (Sketch)]
        \begin{columns}
            \begin{column}{0.5\textwidth}
                \begin{itemize}
                    \item Let $z\in V(T)$ be the \alert{nearest common ancestor} of all $f'\in F_{d'}(v)$.
                    \item Choose $f^*=\argmin_{f'\in F_{d'}(v)}d_T(f',z)$.
                \end{itemize}
            \end{column}
            \begin{column}{0.5\textwidth}
                \begin{figure}
                    \centering
                    \input{tikz/tree_example.tex}
                \end{figure}
            \end{column}
        \end{columns}
    \end{proof}
\end{frame}

\begin{frame}{Trees}
        \begin{algorithm}[H]\label{alg:tree}
            \caption{(Outline)}
            \begin{algorithmic}[1]
                \For{$i=1,...,k$}
                    \While{$V$ not covered by $X_i$}
                        \State Choose $v\in V$ with maximal depth $d(v)$
                        \State Compute $f^*$ as in the previous lemma
                        \State Add $f^*$ to $X_i$
                    \EndWhile
                \EndFor
            \end{algorithmic}
        \end{algorithm}
\end{frame}

\begin{frame}{Trees}
    \begin{theorem}[Correctness]
        The algorithm computes an optimal solution in polynomial time.
    \end{theorem}
    \begin{proof}[Proof (Outline).]
        \begin{itemize}
            \item \textbf{Local Optimality of $X_i$:} Induction on $|V|$ using the properties of $f^*$.
            \item \textbf{Global Optimality of $X$:} Inductively show that each partial solution $(X_1,...,X_i)$ is extensible to a an optimal solution.
        \end{itemize}
        
    \end{proof}
\end{frame}